document.addEventListener("DOMContentLoaded", () => {
    var mymap = L.map("gpsmap").setView([38.891, 139.824], 13);
    L.tileLayer('https://{s}.tile.osm.org/{z}/{x}/{y}.png', {
	attribution:
	'&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> \
		contributors'
    }).addTo(mymap);

    var gpsmarker = L.marker(mymap.getCenter()).addTo(mymap);
    gpsmarker.bindPopup("STARTを押して始まるよ！").openPopup();
	
   
var myIcon = L.icon({
    iconUrl: 'goal.png.png',
    iconSize: [40, 40] 
});
L.marker([38.885506,139.863693], {icon: myIcon}).addTo(mymap);
//参考https://cpoint-lab.co.jp/article/201905/9485/
	
var pg1 = [			// Polygon: ポリゴン
	    [38.894,139.809],
	    [38.883,139.829],
	    [38.871,139.818],		// 終点と始点は連結される
	];
	var pgOpt1 = {			// polygonに与えるオプション
	    color: "blue",		// 線分の色
	    fillColor: "pink",		// 塗りつぶし部分の色
	    fillOpacity: 0.5		// 塗りつぶし部分の透明度
	};

	L.polygon(pg1, pgOpt1).addTo(mymap);
	
	
	
		var pg = [			// Polygon: ポリゴン
	    [38.889,139.853],
	    [38.882,139.845],
	    [38.890,139.846],
	    [38.893,139.855],		// 終点と始点は連結される
	];
	var pgOpt = {			// polygonに与えるオプション
	    color: "red",		// 線分の色
	    fillColor: "pink",		// 塗りつぶし部分の色
	    fillOpacity: 0.2		// 塗りつぶし部分の透明度
	};
	L.polygon(pg, pgOpt).addTo(mymap);
	
	
	var pg2 = [			
	    [38.910,139.832],
	    [38.915,139.846],
	    [38.919,139.841],
	];
	var pgOpt2 = {			
	    color: "red",		
	    fillColor: "pink",		
	    fillOpacity: 0.4		
	};
	L.polygon(pg2, pgOpt2).addTo(mymap);
	
	var pg3 = [			
	    [38.903,139.845],
	    [38.899,139.845],
	    [38.908,139.859],
	];
	var pgOpt3 = {			
	    color: "blue",		
	    fillColor: "pink",		
	    fillOpacity: 0.4		
	};
	L.polygon(pg3, pgOpt3).addTo(mymap);
	
	var pgobj = L.polygon(pg, pgOpt).addTo(mymap);
	pgobj.bindPopup("danger!");
	var pgobj1 = L.polygon(pg1, pgOpt1).addTo(mymap);
	pgobj1.bindPopup("danger!");
	var pgobj2 = L.polygon(pg2, pgOpt2).addTo(mymap);
	pgobj2.bindPopup("danger!");
	 var pgobj3 = L.polygon(pg3, pgOpt3).addTo(mymap);
	pgobj3.bindPopup("danger!");
	  
    var nTrial = 100
    var watchId = null;		// 最初はnullにしておく
    function stopGPS() {	// watchが動いていたら止めてnullにする
	console.log("watchId="+watchId);
	if (watchId != null) {	// nullかどうかで比較しないとだめ(初期値0)
	    navigator.geolocation.clearWatch(watchId);
	    document.getElementById("title").textContent = "stop";
	    gpsmarker.setPopupContent("停めました");
	}
	watchId = null;
    }
    function tryWatchGPS() {
	stopGPS();		// 二重で動かないように注意する
	watchId = navigator.geolocation.watchPosition(
	    onSuccess, onError,{
		maximumAge: 0, timeout: 3000, enableHighAccuracy: true});
	document.getElementById("title").textContent = "START!!";
    }
    function onSuccess(pos) {	// GPS信号が取れたらここに来る
	var latlng = L.latLng([pos.coords.latitude, pos.coords.longitude]);
	mymap.panTo(latlng);// 地図の中心をそこにする
	console.log(latlng);
	// ★★★★★ ここから
	gpsmarker.setLatLng(latlng).setPopupContent(
	    "ここの緯度は、lat="+latlng.lat+", 経度は、lng="+latlng.lng+"だよ ."
	).openPopup();
	var x = latlng.lat, y = latlng.lng;
	if(x > 38.884 && x < 38.889 && y > 139.8608 && y <139.8673){
	    alert("ごーる!!");
	    stopGPS();
	}else {
	    document.getElementByID("title").textContent
		="危険地帯があるので気を付けてね";
	}

    }
    function onError(err) {
	restN = "あと"+(--nTrial)+"回試行します。";
	gpsmarker.setPopupContent("捕捉失敗:"+restN).openPopup();
	if (nTrial <= 0) {
	    navigator.geolocation.clearWatch(watchId);
	}
    }
    // STARTボタンに開始を仕込む
    document.getElementById("start").addEventListener("click", tryWatchGPS);
    // STOPボタンに停止を仕込む
    document.getElementById("stop").addEventListener("click", stopGPS);
}, false);
